'From Haver 5.0 [latest update: #4559] on 22 March 2021 at 6:22:15 pm'!
'Description This package contains all refactoring classes that are environment/module aware.'!
!provides: 'ModulesRefactorings' 1 5!
SystemOrganization addCategory: 'ModulesRefactorings'!


!moduleCreation: ModulesRefactorings!
Modules newEnvironment: #ModulesRefactorings!

!interfacesOf: ModulesRefactorings!
Modules environment: #ModulesRefactorings ::
	interface: #API exporting: #() ::
	interface: #SPI aliasFor: #API!


!classDefinition: (Modules>>#ModulesRefactorings>>#AbstractEnvironmentAwareInsertSuperclass) category: 'ModulesRefactorings'!
InsertSuperclass subclass: #AbstractEnvironmentAwareInsertSuperclass
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ModulesRefactorings'
	inModule: #ModulesRefactorings!
!classDefinition: (Modules>>#ModulesRefactorings>>#AbstractEnvironmentAwareInsertSuperclass) class category: 'ModulesRefactorings'!
(Modules>>#ModulesRefactorings>>#AbstractEnvironmentAwareInsertSuperclass) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclass) category: 'ModulesRefactorings'!
(Modules>>#ModulesRefactorings>>#AbstractEnvironmentAwareInsertSuperclass) subclass: #EnvironmentAwareInsertSuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ModulesRefactorings'
	inModule: #ModulesRefactorings!
!classDefinition: (Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclass) class category: 'ModulesRefactorings'!
(Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclass) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ModulesRefactorings>>#ModuleAwareInsertSuperclass) category: 'ModulesRefactorings'!
(Modules>>#ModulesRefactorings>>#AbstractEnvironmentAwareInsertSuperclass) subclass: #ModuleAwareInsertSuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ModulesRefactorings'
	inModule: #ModulesRefactorings!
!classDefinition: (Modules>>#ModulesRefactorings>>#ModuleAwareInsertSuperclass) class category: 'ModulesRefactorings'!
(Modules>>#ModulesRefactorings>>#ModuleAwareInsertSuperclass) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ModulesRefactorings>>#SimpleEnvironmentAwareInsertSuperclass) category: 'ModulesRefactorings'!
(Modules>>#ModulesRefactorings>>#AbstractEnvironmentAwareInsertSuperclass) subclass: #SimpleEnvironmentAwareInsertSuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ModulesRefactorings'
	inModule: #ModulesRefactorings!
!classDefinition: (Modules>>#ModulesRefactorings>>#SimpleEnvironmentAwareInsertSuperclass) class category: 'ModulesRefactorings'!
(Modules>>#ModulesRefactorings>>#SimpleEnvironmentAwareInsertSuperclass) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclassApplier) category: 'ModulesRefactorings'!
InsertSuperclassApplier subclass: #EnvironmentAwareInsertSuperclassApplier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ModulesRefactorings'
	inModule: #ModulesRefactorings!
!classDefinition: (Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclassApplier) class category: 'ModulesRefactorings'!
(Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclassApplier) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ModulesRefactorings>>#EnvirnomentAwareRenameClassApplier) category: 'ModulesRefactorings'!
RenameClassApplier subclass: #EnvirnomentAwareRenameClassApplier
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ModulesRefactorings'
	inModule: #ModulesRefactorings!
!classDefinition: (Modules>>#ModulesRefactorings>>#EnvirnomentAwareRenameClassApplier) class category: 'ModulesRefactorings'!
(Modules>>#ModulesRefactorings>>#EnvirnomentAwareRenameClassApplier) class
	instanceVariableNames: ''!


!(Modules>>#ModulesRefactorings>>#AbstractEnvironmentAwareInsertSuperclass) commentStamp: '<historical>' prior: 0!
I am the abstract base class of all enviroment aware superclass inserters.!

!(Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclass) commentStamp: '<historical>' prior: 0!
I am an environment aware super class inserter.!

!(Modules>>#ModulesRefactorings>>#ModuleAwareInsertSuperclass) commentStamp: '<historical>' prior: 0!
I am an module aware super class inserter.!

!(Modules>>#ModulesRefactorings>>#SimpleEnvironmentAwareInsertSuperclass) commentStamp: '<historical>' prior: 0!
I am an environment aware super class inserter for simple environments.!

!(Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclassApplier) commentStamp: '<historical>' prior: 0!
I am the environment aware version of an InsertSuperclassApplier!

!(Modules>>#ModulesRefactorings>>#EnvirnomentAwareRenameClassApplier) commentStamp: '<historical>' prior: 0!
I am an environment aware class renamer.!

!(Modules>>#ModulesRefactorings>>#AbstractEnvironmentAwareInsertSuperclass) methodsFor: 'initialization' stamp: 'KLG 12/7/2020 12:10:01'!
initializeTo: aClass named: aSuperclassName in: anEnvironment
	"Initialize me."
	
	super initializeTo: aClass named: aSuperclassName.
	environment _ anEnvironment ! !

!(Modules>>#ModulesRefactorings>>#AbstractEnvironmentAwareInsertSuperclass) class methodsFor: 'instance creation' stamp: 'KLG 1/5/2021 15:34:23'!
to: aClass named: aSuperclassName
	
	self flagHaver: 'TODO: Add undeclared handling!!'.
	^ self to: aClass named: aSuperclassName in: aClass class environment undeclared: Undeclared! !

!(Modules>>#ModulesRefactorings>>#AbstractEnvironmentAwareInsertSuperclass) class methodsFor: 'instance creation' stamp: 'KLG 12/7/2020 12:10:21'!
to: aClass named: aSuperclassName in: aSystem undeclared: anUndeclared

	self newClassPreconditionClass valueFor: aSuperclassName in: aSystem undeclared: anUndeclared.
	
	^self new initializeTo: aClass theNonMetaClass named: aSuperclassName in: aSystem! !

!(Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclass) methodsFor: 'applying - private' stamp: 'KLG 12/7/2020 12:13:17'!
changeSuperclassTo: newSuperclass
	
	newSuperclass subclass: classToRefactor name
		instanceVariableNames: classToRefactor instanceVariablesString 
		classVariableNames: classToRefactor classVariablesString 
		poolDictionaries: classToRefactor sharedPoolsString
		category: classToRefactor category
		inEnvironment: classToRefactor class environment name! !

!(Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclass) methodsFor: 'applying - private' stamp: 'KLG 12/7/2020 12:13:48'!
createSuperclass
	
	^classToRefactor superclass subclass: superclassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: classToRefactor category
		inEnvironment: classToRefactor class environment name! !

!(Modules>>#ModulesRefactorings>>#ModuleAwareInsertSuperclass) methodsFor: 'applying - private' stamp: 'KLG 12/7/2020 12:07:57'!
changeSuperclassTo: newSuperclass
	
	newSuperclass subclass: classToRefactor name
		instanceVariableNames: classToRefactor instanceVariablesString 
		classVariableNames: classToRefactor classVariablesString 
		poolDictionaries: classToRefactor sharedPoolsString
		category: classToRefactor category
		inModule: classToRefactor class environment name! !

!(Modules>>#ModulesRefactorings>>#ModuleAwareInsertSuperclass) methodsFor: 'applying - private' stamp: 'KLG 12/7/2020 12:07:41'!
createSuperclass
	
	^classToRefactor superclass subclass: superclassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: classToRefactor category
		inModule: classToRefactor class environment name! !

!(Modules>>#ModulesRefactorings>>#SimpleEnvironmentAwareInsertSuperclass) methodsFor: 'applying - private' stamp: 'KLG 12/7/2020 12:15:01'!
changeSuperclassTo: newSuperclass
	
	newSuperclass subclass: classToRefactor name
		instanceVariableNames: classToRefactor instanceVariablesString 
		classVariableNames: classToRefactor classVariablesString 
		poolDictionaries: classToRefactor sharedPoolsString
		category: classToRefactor category
		inSimpleEnvironment: classToRefactor class environment name! !

!(Modules>>#ModulesRefactorings>>#SimpleEnvironmentAwareInsertSuperclass) methodsFor: 'applying - private' stamp: 'KLG 12/7/2020 12:15:17'!
createSuperclass
	
	^classToRefactor superclass subclass: superclassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: classToRefactor category
		inSimpleEnvironment: classToRefactor class environment name! !

!(Modules>>#ModulesRefactorings>>#EnvironmentAwareInsertSuperclassApplier) methodsFor: 'refactoring - creation' stamp: 'KLG 12/7/2020 12:23:11'!
createRefactoring

	classToRefactor name doWithEnvironmentIfAware: [ :environment | 	| inserterClass |
		inserterClass _ environment class caseOf: {
			[ SimpleEnvironment ] -> [ SimpleEnvironmentAwareInsertSuperclass ].
			[ `SimpleEnvironments >> #Environments >> #Environment` ] -> [ EnvironmentAwareInsertSuperclass ].
			[ `Environments >> #Modules >> #Module` ] -> [ ModuleAwareInsertSuperclass ] }.
		^ inserterClass 
			to: classToRefactor 
			named: newSuperclassName ].
	^ super createRefactoring! !

!(Modules>>#ModulesRefactorings>>#EnvirnomentAwareRenameClassApplier) methodsFor: 'environment' stamp: 'KLG 12/5/2020 18:34:43'!
environment
	"Answer the environment to use."

	^ environment ifNil: [ Smalltalk ]! !

!(Modules>>#ModulesRefactorings>>#EnvirnomentAwareRenameClassApplier) methodsFor: 'refactoring - parameters request' stamp: 'KLG 12/5/2020 18:32:28'!
askNewClassName
	"Ask the user for a new class name.
	
	Convert the string from the user to an environment aware symbol
	if the old name is an environment local symbol."

	| oldClassName |
	newClassName _ self
		request: 'Enter new name:'
		initialAnswer: (oldClassName _ classToRename name).
	newClassName _ newClassName withBlanksTrimmed asSymbol.
	oldClassName doWithEnvironmentIfAware: [ :symbolEnvironment |
		environment _ symbolEnvironment.
		newClassName _ newClassName forEnvironment: symbolEnvironment ]
	
	! !

!(Modules>>#ModulesRefactorings>>#EnvirnomentAwareRenameClassApplier) methodsFor: 'refactoring - creation' stamp: 'KLG 12/5/2020 18:35:58'!
createRefactoring
	"Deletgate the actual work to the rename class refactorer."

	^RenameClass
		from: classToRename
		to: newClassName in: self environment
		undeclared: Undeclared.
	
! !

!Browser methodsFor: '*ModulesRefactorings' stamp: 'KLG 12/7/2020 12:05:31'!
insertSuperclass

	self selectedClassOrMetaClass ifNotNil: [ :aBehavior |
		(`Modules >> #ModulesRefactorings >> #EnvironmentAwareInsertSuperclassApplier`
			on: self
			for: aBehavior theNonMetaClass) value ].! !

!Browser methodsFor: '*ModulesRefactorings' stamp: 'KLG 12/5/2020 18:10:12'!
renameClass

	self selectedClassOrMetaClass ifNotNil: [ :aBehavior |
		(`Modules>> #ModulesRefactorings >> #EnvirnomentAwareRenameClassApplier`
			for: aBehavior theNonMetaClass)				value ].! !

!SmalltalkEditor methodsFor: '*ModulesRefactorings' stamp: 'KLG 12/5/2020 18:10:34'!
renameClassOn: aBrowser for: aClassToRefactor

	(`Modules>> #ModulesRefactorings >> #EnvirnomentAwareRenameClassApplier`
		for: aClassToRefactor) value! !
