'From Haver 5.0 [latest update: #4559] on 22 March 2021 at 6:23:35 pm'!
'Description I provide morphs that provide a similar interface to their model as the a system window
does.

This should make MVC, or PmM (PluggableMorph Model), code useable in system windows and submorphs.'!
!provides: 'SystemMorphs' 1 4!
!requires: 'Modules' 1 57 nil!
SystemOrganization addCategory: 'SystemMorphs'!


!moduleCreation: SystemMorphs!
Modules newEnvironment: #SystemMorphs!

!interfacesOf: SystemMorphs!
Modules environment: #SystemMorphs ::
	interface: #API exporting: #(#SystemWindow #AbstractSystemMorphModel #AbstractSystemMorph ) ::
	interface: #SPI aliasFor: #API!


!classDefinition: (Modules>>#SystemMorphs>>#AbstractSystemMorphModel) category: 'SystemMorphs'!
ActiveModel subclass: #AbstractSystemMorphModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemMorphs'
	inModule: #SystemMorphs!
!classDefinition: (Modules>>#SystemMorphs>>#AbstractSystemMorphModel) class category: 'SystemMorphs'!
(Modules>>#SystemMorphs>>#AbstractSystemMorphModel) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SystemMorphs>>#AbstractSystemMorph) category: 'SystemMorphs'!
LayoutMorph subclass: #AbstractSystemMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemMorphs'
	inModule: #SystemMorphs!
!classDefinition: (Modules>>#SystemMorphs>>#AbstractSystemMorph) class category: 'SystemMorphs'!
(Modules>>#SystemMorphs>>#AbstractSystemMorph) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#SystemMorphs>>#SystemWindow) category: 'SystemMorphs'!
SystemWindow subclass: #SystemWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemMorphs'
	inModule: #SystemMorphs!
!classDefinition: (Modules>>#SystemMorphs>>#SystemWindow) class category: 'SystemMorphs'!
(Modules>>#SystemMorphs>>#SystemWindow) class
	instanceVariableNames: ''!


!(Modules>>#SystemMorphs>>#AbstractSystemMorph) commentStamp: '<historical>' prior: 0!
I am the abstract base class of all system morphs.!

!(Modules>>#SystemMorphs>>#AbstractSystemMorph) class methodsFor: 'instance creation' stamp: 'KLG 12/21/2020 17:36:31'!
initializedInstance
	"Answer an initialized instance of mine."

	| model |
	^ self new 
		model: (model _ self initializedModelBlock value);
		buildMorphicWidget;
		adoptWidgetsColor: (model class windowColor);
		yourself! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorphModel) methodsFor: 'instance creation' stamp: 'KLG 12/9/2020 17:46:22'!
browserMorphClass
	"Answer the toplevel morph class for this model."

	^ self class browserMorphClass! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorphModel) methodsFor: 'instance creation' stamp: 'KLG 12/9/2020 17:47:33'!
hollowBrowserMorph
	"Answer a new instance of the right browser morph.
	
	Do not build its submorph structure."

	^ self browserMorphClass new model: self! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorphModel) methodsFor: 'browsing' stamp: 'KLG 12/9/2020 17:46:09'!
browserMorph
	"Answer a new instance of the right toplevel morph."

	^ (self hollowBrowserMorph) buildMorphicWidget; yourself.! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorphModel) methodsFor: 'browsing' stamp: 'KLG 12/9/2020 17:45:23'!
model
	"Answer my model, which I am myself."! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorphModel) methodsFor: 'user interface support' stamp: 'KLG 12/9/2020 17:48:22'!
mySystemWindowsDo: aBlock
	"Evaluate a block for all system windows that have me as a model."

	self runningWorld allMorphsDo: [ :morph |
		morph is: #SystemWindow :: ifTrue: [
			morph model == self ifTrue: [ aBlock value: morph ] ] ]! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorphModel) class methodsFor: 'instance creation' stamp: 'KLG 12/9/2020 17:49:16'!
browserMorphClass
	"Answer the toplevel morph class for this model."

	^ self subclassResponsibility! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorph) methodsFor: 'GUI building' stamp: 'KLG 12/9/2020 17:40:27'!
buildMorphicWidget
	"Build the morphic structure for this widget.
	
	If you like you may answer a different top level morph."
	
	^ self subclassResponsibility! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorph) methodsFor: 'accessing' stamp: 'KLG 12/9/2020 17:39:21'!
model
	"Answer the value of model"

	^ model! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorph) methodsFor: 'accessing' stamp: 'KLG 12/9/2020 17:39:21'!
model: anObject
	"Set the value of model"

	model _ anObject! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorph) class methodsFor: 'instance creation' stamp: 'KLG 12/20/2020 20:55:38'!
initializedModelBlock
	"Answer a block that constructs an initilaized model.
	
	Answer nil if you do not want to participate in the new morph menu."

	^ nil! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorph) class methodsFor: 'instance creation' stamp: 'KLG 12/9/2020 21:25:54'!
new
	"Answer a new column morph."

	^ self newColumn! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorph) class methodsFor: 'new-morph participation' stamp: 'KLG 12/20/2020 20:48:59'!
categoryInNewMorphMenu
	^ 'Tools'! !

!(Modules>>#SystemMorphs>>#AbstractSystemMorph) class methodsFor: 'new-morph participation' stamp: 'KLG 12/20/2020 20:57:06'!
includeInNewMorphMenu
	"Return true for all classes that can be instantiated from the menu"
	
	^ self initializedModelBlock notNil! !

!(Modules>>#SystemMorphs>>#SystemWindow) methodsFor: 'GUI building' stamp: 'KLG 12/21/2020 17:26:29'!
windowColor
	"I am used for browsers."
	
	^ [ self model class windowColor ] onDNU: #windowColor do: [ Theme current browser ]! !

!(Modules>>#SystemMorphs>>#SystemWindow) class methodsFor: 'instance creation' stamp: 'KLG 12/9/2020 17:33:34'!
open: aBrowserMorph on: aModel
	"Open a new instance of mine containing a toplevel morph."

	| window |
	window _ self new
		model: aModel;
		addMorph:  aBrowserMorph buildMorphicWidget.
	window 	openInWorld.
	aModel changed: #relabel.
	^ window
! !

!(Modules>>#SystemMorphs>>#SystemWindow) class methodsFor: 'instance creation' stamp: 'KLG 12/9/2020 17:34:26'!
openOn: aModelProvider
	"Open the window on a model."

	| model |
	^ self open: (model _ aModelProvider model) hollowBrowserMorph on: model! !
